-- Horse Artillery Custom Missions
-- Author: Wolfdog
--------------------------------------------------------------
print("This is the 'Horse Artillery' mod script.")
-- Fire Guns
local iMissionFire  = GameInfoTypes.MISSION_FIRE_GUNS

local CUSTOM_MISSION_NO_ACTION = 0
local CUSTOM_MISSION_ACTION    = 1

-- Change to Horse Artillery (Fire Guns)

function OnFireMissionPossible(iPlayer, iUnit, iMission, iData1, iData2, _, _, iPlotX, iPlotY, bTestVisible)
	local pPlayer = Players[iPlayer]
	local pUnit = pPlayer:GetUnitByID(iUnit)
	
	if (pPlayer:IsAlive() and not pPlayer:IsBarbarian() and iMission == iMissionFire and pUnit:CanMove()) then
	
		if (pUnit:GetUnitType() == GameInfoTypes.UNIT_HORSE_ARTILLERY_MOVE or pUnit:GetUnitType() == GameInfoTypes.UNIT_WW1_HORSE_ARTY_MOVE) then
			return true
		end
	end
	
	return false
end
GameEvents.CustomMissionPossible.Add(OnFireMissionPossible)

function OnFireMissionStart(iPlayer, iUnit, iMission, iData1, iData2, iFlags, iTurn)
	local pPlayer = Players[iPlayer]
	local pUnit = pPlayer:GetUnitByID(iUnit)
	local pMoves = GameDefines.MOVE_DENOMINATOR
	
	if (pPlayer:IsAlive() and not pPlayer:IsBarbarian() and iMission == iMissionFire and pUnit:CanMove()) then
	
		if (pUnit:GetUnitType() == GameInfoTypes.UNIT_HORSE_ARTILLERY_MOVE) then
			local pUnitCannon = pPlayer:InitUnit(GameInfoTypes["UNIT_HORSE_ARTILLERY"], pUnit:GetX(), pUnit:GetY())
			
			pUnitCannon:SetEmbarked(pUnit:IsEmbarked())
			pUnitCannon:SetDamage(pUnit:GetDamage())
			pUnitCannon:SetExperience(pUnit:GetExperience())
			pUnitCannon:SetLevel(pUnit:GetLevel())
			pUnitCannon:SetMoves(pUnitCannon:MaxMoves())
			pUnitCannon:PushMission(MissionTypes.MISSION_SET_UP_FOR_RANGED_ATTACK, pUnitCannon:GetX(), pUnitCannon:GetY(), 0, 0, 1, MissionTypes.MISSION_SET_UP_FOR_RANGED_ATTACK, pUnitCannon:GetPlot(), pUnitCannon)
			
			for unitPromotion in GameInfo.UnitPromotions() do
				local iPromotionID = unitPromotion.ID;
					
				if (pUnit:IsHasPromotion(iPromotionID)) then
					if (pUnitCannon:IsPromotionValid(iPromotionID)) then
						pUnitCannon:SetHasPromotion(iPromotionID, true)
					end
				end
			end
			
			pUnit:Kill(true)
		
		elseif (pUnit:GetUnitType() == GameInfoTypes.UNIT_WW1_HORSE_ARTY_MOVE) then
			local pUnitHowitzer = pPlayer:InitUnit(GameInfoTypes["UNIT_WW1_HORSE_ARTY"], pUnit:GetX(), pUnit:GetY())
			
			pUnitHowitzer:SetEmbarked(pUnit:IsEmbarked())
			pUnitHowitzer:SetDamage(pUnit:GetDamage())
			pUnitHowitzer:SetExperience(pUnit:GetExperience())
			pUnitHowitzer:SetLevel(pUnit:GetLevel())
			pUnitHowitzer:SetMoves(pUnitHowitzer:MaxMoves())
			pUnitHowitzer:PushMission(MissionTypes.MISSION_SET_UP_FOR_RANGED_ATTACK, pUnitHowitzer:GetX(), pUnitHowitzer:GetY(), 0, 0, 1, MissionTypes.MISSION_SET_UP_FOR_RANGED_ATTACK, pUnitHowitzer:GetPlot(), pUnitHowitzer)
			
			for unitPromotion in GameInfo.UnitPromotions() do
				local iPromotionID = unitPromotion.ID;
					
				if (pUnit:IsHasPromotion(iPromotionID)) then
					if (pUnitHowitzer:IsPromotionValid(iPromotionID)) then
						pUnitHowitzer:SetHasPromotion(iPromotionID, true)
					end
				end
			end
			
			pUnit:Kill(true)
		end
	end
	
	return CUSTOM_MISSION_NO_ACTION
end
GameEvents.CustomMissionStart.Add(OnFireMissionStart)

function OnFireMissionCompleted(iPlayer, iUnit, iMission, iData1, iData2, iFlags, iTurn)
	local pPlayer = Players[iPlayer]
	
	if (pPlayer:IsAlive() and not pPlayer:IsBarbarian() and iMission == iMissionFire) then
		return true
	end
	
	return false
end
GameEvents.CustomMissionCompleted.Add(OnFireMissionCompleted)

-- Limber Guns
local iMissionLimber  = GameInfoTypes.MISSION_LIMBER_GUNS

local CUSTOM_MISSION_NO_ACTION = 0
local CUSTOM_MISSION_ACTION    = 1

-- Change to Horse Artillery Move (Limbered)

function OnLimberMissionPossible(iPlayer, iUnit, iMission, iData1, iData2, _, _, iPlotX, iPlotY, bTestVisible)
	local pPlayer = Players[iPlayer]
	local pUnit = pPlayer:GetUnitByID(iUnit)
	
	if (pPlayer:IsAlive() and not pPlayer:IsBarbarian() and iMission == iMissionLimber and not pUnit:HasMoved()) then
	
		if (pUnit:GetUnitType() == GameInfoTypes.UNIT_HORSE_ARTILLERY or pUnit:GetUnitType() == GameInfoTypes.UNIT_WW1_HORSE_ARTY) then
			return true
		end
	end
	
	return false
end
GameEvents.CustomMissionPossible.Add(OnLimberMissionPossible)

function OnLimberMissionStart(iPlayer, iUnit, iMission, iData1, iData2, iFlags, iTurn)
	local pPlayer = Players[iPlayer]
	local pUnit = pPlayer:GetUnitByID(iUnit)
	local pMoves = GameDefines.MOVE_DENOMINATOR
	
	if (pPlayer:IsAlive() and not pPlayer:IsBarbarian() and iMission == iMissionLimber and not pUnit:HasMoved()) then
	
		if (pUnit:GetUnitType() == GameInfoTypes.UNIT_HORSE_ARTILLERY) then
			local pUnitLimber = pPlayer:InitUnit(GameInfoTypes["UNIT_HORSE_ARTILLERY_MOVE"], pUnit:GetX(), pUnit:GetY())
			
			pUnitLimber:SetEmbarked(pUnit:IsEmbarked())
			pUnitLimber:SetDamage(pUnit:GetDamage())
			pUnitLimber:SetExperience(pUnit:GetExperience())
			pUnitLimber:SetLevel(pUnit:GetLevel())
			pUnitLimber:SetMoves(pUnitLimber:MaxMoves() - pMoves)
			
			for unitPromotion in GameInfo.UnitPromotions() do
				local iPromotionID = unitPromotion.ID;
					
				if (pUnit:IsHasPromotion(iPromotionID)) then
					if (pUnitLimber:IsPromotionValid(iPromotionID)) then
						pUnitLimber:SetHasPromotion(iPromotionID, true)
					end
				end
			end
			
			pUnit:Kill(true)
			
		elseif (pUnit:GetUnitType() == GameInfoTypes.UNIT_WW1_HORSE_ARTY) then
			local pUnitWWILimber = pPlayer:InitUnit(GameInfoTypes["UNIT_WW1_HORSE_ARTY_MOVE"], pUnit:GetX(), pUnit:GetY())
			
			pUnitWWILimber:SetEmbarked(pUnit:IsEmbarked())
			pUnitWWILimber:SetDamage(pUnit:GetDamage())
			pUnitWWILimber:SetExperience(pUnit:GetExperience())
			pUnitWWILimber:SetLevel(pUnit:GetLevel())
			pUnitWWILimber:SetMoves(pUnitWWILimber:MaxMoves() - pMoves)
			
			for unitPromotion in GameInfo.UnitPromotions() do
				local iPromotionID = unitPromotion.ID;
					
				if (pUnit:IsHasPromotion(iPromotionID)) then
					if (pUnitWWILimber:IsPromotionValid(iPromotionID)) then
						pUnitWWILimber:SetHasPromotion(iPromotionID, true)
					end
				end
			end
			
			pUnit:Kill(true)
		end
	end
	
	return CUSTOM_MISSION_NO_ACTION
end
GameEvents.CustomMissionStart.Add(OnLimberMissionStart)

function OnLimberMissionCompleted(iPlayer, iUnit, iMission, iData1, iData2, iFlags, iTurn)
	local pPlayer = Players[iPlayer]
	
	if (pPlayer:IsAlive() and not pPlayer:IsBarbarian() and iMission == iMissionLimber) then
		return true
	end
	
	return false
end
GameEvents.CustomMissionCompleted.Add(OnLimberMissionCompleted)